Index: src/event.h
===================================================================
RCS file: /data/cvs/libvirt/src/event.h,v
retrieving revision 1.2
diff -u -r1.2 event.h
--- src/event.h	19 Sep 2007 01:27:32 -0000	1.2
+++ src/event.h	27 Feb 2008 10:09:13 -0000
@@ -28,7 +28,7 @@
 /**
  * virEventHandleCallback: callback for receiving file handle events
  *
- * @fd: file handle on which the event occured
+ * @fd: file handle on which the event occurred
  * @events: bitset of events from POLLnnn constants
  * @opaque: user data registered with handle
  */
@@ -38,8 +38,8 @@
  * virEventAddHandle: register a callback for monitoring file handle events
  *
  * @fd: file handle to monitor for events
- * @events: bitset of events to wach from POLLnnn constants
- * @cb: callback to invoke when an event occurrs
+ * @events: bitset of events to watch from POLLnnn constants
+ * @cb: callback to invoke when an event occurs
  * @opaque: user data to pass to callback
  *
  * returns -1 if the file handle cannot be registered, 0 upon success
@@ -50,7 +50,7 @@
  * virEventUpdateHandle: change event set for a monitored file handle
  *
  * @fd: file handle to monitor for events
- * @events: bitset of events to wach from POLLnnn constants
+ * @events: bitset of events to watch from POLLnnn constants
  *
  * Will not fail if fd exists
  */
@@ -77,7 +77,7 @@
  * virEventAddTimeout: register a callback for a timer event
  *
  * @frequency: time between events in milliseconds
- * @cb: callback to invoke when an event occurrs
+ * @cb: callback to invoke when an event occurs
  * @opaque: user data to pass to callback
  *
  * Setting frequency to -1 will disable the timer. Setting the frequency
Index: src/iptables.c
===================================================================
RCS file: /data/cvs/libvirt/src/iptables.c,v
retrieving revision 1.22
diff -u -r1.22 iptables.c
--- src/iptables.c	22 Feb 2008 16:26:13 -0000	1.22
+++ src/iptables.c	27 Feb 2008 10:09:13 -0000
@@ -544,7 +544,7 @@
  * iptablesContextFree:
  * @ctx: pointer to the IP table context
  *
- * Free the ressources associated with an IP table context
+ * Free the resources associated with an IP table context
  */
 void
 iptablesContextFree(iptablesContext *ctx)
@@ -663,7 +663,7 @@
  * @iface: the interface name
  * @port: the TCP port to remove
  *
- * Removes an input from the IP table, hence forbiding access to the given
+ * Removes an input from the IP table, hence forbidding access to the given
  * @port on the given @iface interface for TCP packets
  *
  * Returns 0 in case of success or an error code in case of error
@@ -702,7 +702,7 @@
  * @iface: the interface name
  * @port: the UDP port to remove
  *
- * Removes an input from the IP table, hence forbiding access to the given
+ * Removes an input from the IP table, hence forbidding access to the given
  * @port on the given @iface interface for UDP packets
  *
  * Returns 0 in case of success or an error code in case of error
Index: src/sexpr.c
===================================================================
RCS file: /data/cvs/libvirt/src/sexpr.c,v
retrieving revision 1.15
diff -u -r1.15 sexpr.c
--- src/sexpr.c	5 Feb 2008 19:27:37 -0000	1.15
+++ src/sexpr.c	27 Feb 2008 10:09:13 -0000
@@ -24,7 +24,7 @@
 /**
  * virSexprError:
  * @conn: the connection if available
- * @error: the error noumber
+ * @error: the error number
  * @info: extra information string
  *
  * Handle an error in the S-Expression code
@@ -289,7 +289,7 @@
  * @end: pointer to an index in the buffer for the already parsed bytes
  *
  * Internal routine implementing the parse of S-Expression
- * Note that failure in this function is catrosphic.  If it returns
+ * Note that failure in this function is catastrophic.  If it returns
  * NULL, you've leaked memory and you're currently OOM.  It will always
  * parse an SEXPR given a buffer
  *
@@ -387,7 +387,7 @@
  * @buffer: a zero terminated buffer containing an S-Expression in UTF-8
  *
  * Parse the S-Expression in the buffer.
- * Note that failure in this function is catrosphic.  If it returns
+ * Note that failure in this function is catastrophic.  If it returns
  * NULL, you've leaked memory and you're currently OOM.  It will always
  * parse an SEXPR given a buffer
  *
Index: src/socketcompat.h
===================================================================
RCS file: /data/cvs/libvirt/src/socketcompat.h,v
retrieving revision 1.3
diff -u -r1.3 socketcompat.h
--- src/socketcompat.h	23 Jan 2008 14:54:41 -0000	1.3
+++ src/socketcompat.h	27 Feb 2008 10:09:13 -0000
@@ -43,7 +43,7 @@
 
 #include <winsock2.h>
 
-/* Socket functions in Windoze don't set errno.  Instead of using errno
+/* Socket functions in Windows don't set errno.  Instead of using errno
  * to test for socket errors, call this function to get the errno.
  */
 static inline int
Index: src/storage_backend.c
===================================================================
RCS file: /data/cvs/libvirt/src/storage_backend.c,v
retrieving revision 1.7
diff -u -r1.7 storage_backend.c
--- src/storage_backend.c	22 Feb 2008 16:26:13 -0000	1.7
+++ src/storage_backend.c	27 Feb 2008 10:09:13 -0000
@@ -335,7 +335,7 @@
  * Run an external program.
  *
  * Read its output and apply a series of regexes to each line
- * When the entire set of regexes has matched consequetively
+ * When the entire set of regexes has matched consecutively
  * then run a callback passing in all the matches
  */
 int
Index: src/storage_backend_disk.c
===================================================================
RCS file: /data/cvs/libvirt/src/storage_backend_disk.c,v
retrieving revision 1.1
diff -u -r1.1 storage_backend_disk.c
--- src/storage_backend_disk.c	20 Feb 2008 15:52:17 -0000	1.1
+++ src/storage_backend_disk.c	27 Feb 2008 10:09:14 -0000
@@ -324,7 +324,7 @@
         STREQ(groups[2], "metadata"))
         return 0;
 
-    /* Remaining data / metdata parts get turn into volumes... */
+    /* Remaining data / metadata parts get turn into volumes... */
     if (STREQ(groups[2], "metadata") ||
         STREQ(groups[2], "data")) {
         virStorageVolDefPtr vol = data;
@@ -338,7 +338,7 @@
         /* ....or free space extents */
         return virStorageBackendDiskMakeFreeExtent(conn, pool, groups);
     } else {
-        /* This codepath should never happen unless someone changed
+        /* This code path should never happen unless someone changed
          * libvirt_parthelper forgot to change this code */
         return -1;
     }
Index: src/storage_conf.c
===================================================================
RCS file: /data/cvs/libvirt/src/storage_conf.c,v
retrieving revision 1.2
diff -u -r1.2 storage_conf.c
--- src/storage_conf.c	22 Feb 2008 16:26:13 -0000	1.2
+++ src/storage_conf.c	27 Feb 2008 10:09:14 -0000
@@ -698,7 +698,7 @@
         goto cleanup;
     }
 
-    /* Auto-generated so delibrately ignore */
+    /* Auto-generated so deliberately ignore */
     /*ret->key = virXPathString("string(/volume/key)", ctxt);*/
 
     capacity = virXPathString("string(/volume/capacity)", ctxt);
Index: src/virterror.c
===================================================================
RCS file: /data/cvs/libvirt/src/virterror.c,v
retrieving revision 1.38
diff -u -r1.38 virterror.c
--- src/virterror.c	20 Feb 2008 15:34:52 -0000	1.38
+++ src/virterror.c	27 Feb 2008 10:09:14 -0000
@@ -20,7 +20,7 @@
 
 static virError lastErr =       /* the last error */
 { 0, 0, NULL, VIR_ERR_NONE, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL };
-static virErrorFunc virErrorHandler = NULL;     /* global error handlet */
+static virErrorFunc virErrorHandler = NULL;     /* global error handler */
 static void *virUserData = NULL;        /* associated data */
 
 /*
@@ -67,7 +67,7 @@
  * Simpler but may not be suitable for multithreaded accesses, in which
  * case use virCopyLastError()
  *
- * Returns a pointer to the last error or NULL if none occured.
+ * Returns a pointer to the last error or NULL if none occurred.
  */
 virErrorPtr
 virGetLastError(void)
@@ -135,7 +135,7 @@
  * Simpler but may not be suitable for multithreaded accesses, in which
  * case use virConnCopyLastError()
  *
- * Returns a pointer to the last error or NULL if none occured.
+ * Returns a pointer to the last error or NULL if none occurred.
  */
 virErrorPtr
 virConnGetLastError(virConnectPtr conn)
@@ -405,7 +405,7 @@
 /**
  * __virErrorMsg:
  * @error: the virErrorNumber
- * @info: usually the first paprameter string
+ * @info: usually the first parameter string
  *
  * Internal routine to get the message associated to an error raised
  * from the library
@@ -668,9 +668,9 @@
 	    break;
     case VIR_ERR_INVALID_MAC:
 	    if (info == NULL)
-		errmsg = _("invalid MAC adress");
+		errmsg = _("invalid MAC address");
 	    else
-		errmsg = _("invalid MAC adress: %s");
+		errmsg = _("invalid MAC address: %s");
 	    break;
     case VIR_ERR_AUTH_FAILED:
 	    if (info == NULL)
Index: src/xen_internal.c
===================================================================
RCS file: /data/cvs/libvirt/src/xen_internal.c,v
retrieving revision 1.113
diff -u -r1.113 xen_internal.c
--- src/xen_internal.c	27 Feb 2008 04:35:08 -0000	1.113
+++ src/xen_internal.c	27 Feb 2008 10:09:15 -0000
@@ -138,7 +138,7 @@
 
 struct xen_v0_getdomaininfo {
     domid_t  domain;	/* the domain number */
-    uint32_t flags;	/* falgs, see before */
+    uint32_t flags;	/* flags, see before */
     uint64_t tot_pages;	/* total number of pages used */
     uint64_t max_pages;	/* maximum number of pages allowed */
     unsigned long shared_info_frame; /* MFN of shared_info struct */
@@ -152,7 +152,7 @@
 
 struct xen_v2_getdomaininfo {
     domid_t  domain;	/* the domain number */
-    uint32_t flags;	/* falgs, see before */
+    uint32_t flags;	/* flags, see before */
     uint64_t tot_pages;	/* total number of pages used */
     uint64_t max_pages;	/* maximum number of pages allowed */
     uint64_t shared_info_frame; /* MFN of shared_info struct */
@@ -171,7 +171,7 @@
 
 struct xen_v2d5_getdomaininfo {
     domid_t  domain;	/* the domain number */
-    uint32_t flags;	/* falgs, see before */
+    uint32_t flags;	/* flags, see before */
     uint64_t tot_pages ALIGN_64;	/* total number of pages used */
     uint64_t max_pages ALIGN_64;	/* maximum number of pages allowed */
     uint64_t shared_info_frame ALIGN_64; /* MFN of shared_info struct */
@@ -809,7 +809,7 @@
 /**
  * xenHypervisorDoV0Op:
  * @handle: the handle to the Xen hypervisor
- * @op: pointer to the hyperviros operation structure
+ * @op: pointer to the hypervisor operation structure
  *
  * Do an hypervisor operation though the old interface,
  * this leads to an hypervisor call through ioctl.
@@ -850,7 +850,7 @@
 /**
  * xenHypervisorDoV1Op:
  * @handle: the handle to the Xen hypervisor
- * @op: pointer to the hyperviros operation structure
+ * @op: pointer to the hypervisor operation structure
  *
  * Do an hypervisor v1 operation, this leads to an hypervisor call through
  * ioctl.
@@ -894,7 +894,7 @@
  * @handle: the handle to the Xen hypervisor
  * @op: pointer to the hypervisor operation structure
  *
- * Do an hypervisor v2 stsyem operation, this leads to an hypervisor
+ * Do an hypervisor v2 system operation, this leads to an hypervisor
  * call through ioctl.
  *
  * Returns 0 in case of success and -1 in case of error.
@@ -1970,7 +1970,7 @@
 #endif
 
     /*
-     * we faild to make any hypercall
+     * we failed to make any hypercall
      */
 
     hypervisor_version = -1;
@@ -2049,7 +2049,7 @@
     }
 
     /*
-     * we faild to make the getdomaininfolist hypercall
+     * we failed to make the getdomaininfolist hypercall
      */
 
     hypervisor_version = -1;
@@ -3183,7 +3183,7 @@
  *	underlying virtualization system (Xen...).
  *
  * Extract information about virtual CPUs of domain, store it in info array
- * and also in cpumaps if this pointer is'nt NULL.
+ * and also in cpumaps if this pointer isn't NULL.
  *
  * Returns the number of info filled in case of success, -1 in case of failure.
  */
Index: src/xen_unified.c
===================================================================
RCS file: /data/cvs/libvirt/src/xen_unified.c,v
retrieving revision 1.37
diff -u -r1.37 xen_unified.c
--- src/xen_unified.c	26 Feb 2008 07:05:18 -0000	1.37
+++ src/xen_unified.c	27 Feb 2008 10:09:15 -0000
@@ -92,7 +92,7 @@
  * @conn: pointer to the hypervisor connection
  *
  * Initializer for previous variables. We currently assume that
- * the number of physical CPU and the numebr of NUMA cell is fixed
+ * the number of physical CPU and the number of NUMA cell is fixed
  * until reboot which might be false in future Xen implementations.
  */
 static void
@@ -111,7 +111,7 @@
  * xenNbCells:
  * @conn: pointer to the hypervisor connection
  *
- * Number of NUMa cells present in the actual Node
+ * Number of NUMA cells present in the actual Node
  *
  * Returns the number of NUMA cells available on that Node
  */